
!CharacterCollection methodsFor: '*tode-gemstone-code' stamp: 'dkh 05/31/2011 12:37'!
lineCount

	| count |
	count := 0.
	self linesDo: [:each | count := count + 1 ].
	^count
! !

!TOClassBrowser methodsFor: '*tode-gemstone-code' stamp: 'DataCurator 07/14/2011 05:34'!
acessesToCV: classVarName from: aClass
	| refs |
	refs := SystemNavigation default allCallsOn: (aClass classPool associationAt: classVarName).
	^ self searchResults: refs labeled: 'References to ' , classVarName , ' in ' , aClass name asString! !

!TOClassBrowser methodsFor: '*tode-gemstone-code' stamp: 'DataCurator 07/14/2011 05:34'!
acessesToIV: instVarName from: aClass
	| coll |
	coll := OrderedCollection new.
	aClass
		withAllSubAndSuperclassesDo: [ :class | (class whichSelectorsAccess: instVarName) do: [ :sel | coll add: (MethodReference class: class selector: sel) ] ].
	^ self searchResults: coll labeled: 'References to ' , instVarName , ' in ' , aClass name asString! !

!TOClassBrowser methodsFor: '*tode-gemstone-code' stamp: 'DataCurator 07/13/2011 16:17'!
allCallsOnClass: aClass
	| methodRefs classNames nodes |
	methodRefs := SystemNavigation default allReferencesTo: aClass name asSymbol.
	^ self searchResults: (methodRefs asArray sort: [ :a :b | a <= b ]) labeled: 'References to ' , aClass name asString! !

!TOClassBrowser methodsFor: '*tode-gemstone-code' stamp: 'dkh 05/20/2011 16:10'!
classDefinitionTemplate: classTemplateType
	| stream |
	classTemplateType == #new
		ifTrue: [ ^ Class templateForSubclassOf: Object name category: self theClass theNonMetaClass category ].

	classTemplateType == #subclass
		ifTrue: [ ^ Class templateForSubclassOf: self theClass name category: self theClass theNonMetaClass category ].
		
	"classTemplateType == #definition"
	stream := WriteStream on: String new.
	stream
		nextPutAll: self theClass definition;
		nextPut: $.;
		cr.
	^ stream contents! !

!TOClassBrowser methodsFor: '*tode-gemstone-code' stamp: 'dkh 07/12/2011 11:37'!
copyClass: oldClass to: newName in: categoryName
	| definition newClass |
	(oldClass environment hasClassNamed: newName) 
		ifTrue: [^ self error: newName , ' already exists'].
	definition := oldClass 
						definitionWithClassName: newName 
						superClassName: (oldClass superClass == nil 
							ifTrue: ['nil'] ifFalse: [oldClass superClass name]).
	newClass := definition evaluate.
	newClass 
		copyMethodsFrom: oldClass 
		dictionaries: GsSession currentSession symbolList.
	newClass classComment: oldClass classComment.
	newClass category: categoryName.
	^ newClass	! !

!TOClassBrowser methodsFor: '*tode-gemstone-code' stamp: 'dkh 05/21/2011 03:20'!
removeClass: main script: s id: id
	(s << (s jQuery id: id) dialog) open.
	TOAbortCommand signal! !

!TOClassBrowser methodsFor: '*tode-gemstone-code' stamp: 'dkh 05/21/2011 03:20'!
renameClass: main script: s id: id
	(s << (s jQuery id: id) dialog) open.
	TOAbortCommand signal! !

!TOClassBrowser methodsFor: '*tode-gemstone-code' stamp: 'DataCurator 07/13/2011 16:34'!
renderClassExplorerOn: html main: main
	self
		renderControl: [ :id :scrpt | 
			html break.
			self
				renderLink: [ :s | 
					| frame |
					frame := self currentSession push: (self allCallsOnClass: self theClass superclass).
					frame selectedCenterTab: #view.
					main updateCenterSideHistory: s ]
				with: [ html strong: self theClass superclass name ]
				on: html.
			html text: ' subclass: '.
			self
				renderLink: [ :s | 
					| frame |
					frame := self currentSession push: (self allCallsOnClass: self theClass).
					frame selectedCenterTab: #view.
					main updateCenterSideHistory: s ]
				with: [ html strong: self theClass name ]
				on: html.
			html
				unorderedList: [ 
					html text: 'instanceVariableNames: '.
					self theClass instVarNames
						do: [ :iv | 
							html space.
							self
								renderLink: [ :s | 
									| frame |
									frame := self currentSession push: (self acessesToIV: iv from: self theClass).
									frame selectedCenterTab: #view.
									main updateCenterSideHistory: s ]
								with: [ html strong: iv ]
								on: html ] ].
			html
				unorderedList: [ 
					html text: 'classVariableNames: '.
					self theClass classVarNames
						do: [ :cv | 
							html space.
							self
								renderLink: [ :s | 
									| frame |
									frame := self currentSession push: (self acessesToCV: cv from: self theClass).
									frame selectedCenterTab: #view.
									main updateCenterSideHistory: s ]
								with: [ html strong: cv ]
								on: html ] ].
			html
				unorderedList: [ 
					html text: 'poolDictionaries: '.
					self theClass theNonMetaClass poolDictionaryNames
						do: [ :sp | 
							html strong: sp ] ].
			html
				unorderedList: [ 
					| cat |
					html text: 'category: '.
					cat := self theClass theNonMetaClass category.
					self
						renderLink: [ :s | 
							| frame |
							frame := self currentSession push: ((
		(SystemOrganizer new listAtCategoryNamed: cat)
			collect: [:className | Smalltalk classNamed: className])
				sortBy: [:a :b | a className <= b className]).
							frame selectedCenterTab: #view.
							main updateCenterSideHistory: s ]
						with: [ html strong: cat ]
						on: html ].
			html break.
			self
				renderLink: [ :s | 
					| frame |
					frame := self currentSession push: (self allCallsOnClass: self theClass).
					frame selectedCenterTab: #view.
					main updateCenterSideHistory: s ]
				with: [ html strong: self theClass name , ' class' ]
				on: html.
			html break.
			html
				unorderedList: [ 
					html text: 'instanceVariableNames: '.
					self theClass class instVarNames
						do: [ :iv | 
							html space.
							self
								renderLink: [ :s | 
									| frame |
									frame := self currentSession push: (self acessesToIV: iv from: self theClass).
									frame selectedCenterTab: #view.
									main updateCenterSideHistory: s ]
								with: [ html strong: iv ]
								on: html ] ] ]
		on: html! !

!Behavior methodsFor: '*tode-gemstone-code' stamp: 'DataCurator 07/13/2011 15:44'!
allCallsOn
	"Answer a SortedCollection of all the methods that refer to me by name or as part of an association in a global dict."


	^ (SystemNavigation default allReferencesTo:  self theNonMetaClass name asSymbol), (SystemNavigation default  allCallsOn:  self theNonMetaClass name)	! !

!Behavior methodsFor: '*tode-gemstone-code' stamp: 'dkh 07/19/2011 11:36'!
authorInitials
    ^MCPlatformSupport authorInitials
! !

!TOMethodSourceBrowser methodsFor: '*tode-gemstone-code' stamp: 'dkh 05/20/2011 16:38'!
moveMethodTo: cat

	self methodClass 
		classify: self selectedMethodSelector
		under: cat.
! !

!TOMethodCategoryBrowser methodsFor: '*tode-gemstone-code' stamp: 'dkh 05/27/2011 10:20'!
selectorsForCategory: cat

	^(cat = '-- all --'
		ifTrue: [ self theClass selectors ]
		ifFalse: [ self theClass selectorsIn: cat ]) asArray.! !

!TOMethodCategoryBrowser methodsFor: '*tode-gemstone-code' stamp: 'dkh 05/27/2011 10:22'!
sortedCategories

	^self theClass categoryNames asArray sorted: [:a :b | a <= b ].! !

!TOSearch methodsFor: '*tode-gemstone-code' stamp: 'DataCurator 07/14/2011 11:48'!
implementorsQueryResults
	<todeSearch: 'Implementors' selector: #implementorsSearch priority: 10>
	| size methods allSelectors ascii |
	methods := OrderedCollection new.
	(size := searchText size) = 0
		ifTrue: [ ^ methods ].
	allSelectors := IdentitySet new.
	self currentSystem
		allBehaviorsDo: [ :beh | 
			beh selectors
				do: [ :each | 
					each size >= size
						ifTrue: [ 
							(each includesString: searchText)
								ifTrue: [ methods add: (self currentSystem methodReferenceClass class: beh selector: each) ] ] ] ].
	^methods sorted: [ :a :b | a actualClass name <= b actualClass name ]! !

!TOSearch methodsFor: '*tode-gemstone-code' stamp: 'DataCurator 07/14/2011 15:56'!
sendersExactQueryResults
	<todeSearch: 'Senders (exact)' selector: #sendersExactSearch priority: 14>
	^(self currentSystem allCallsOn: searchText asSymbol) asSet asArray sorted: [:a :b | a actualClass name <= b actualClass name ]! !

!TOSearch methodsFor: '*tode-gemstone-code' stamp: 'dkh 07/25/2011 17:43'!
sendersQueryResults
	<todeSearch: 'Senders' selector: #sendersSearch priority: 15>
	|  methods allMethods ascii |
      
	methods := OrderedCollection new.
	searchText size = 0 ifTrue: [^methods].
      	self currentSystem allBehaviorsDo: [:beh | 
		{beh. beh class} do: [ :cls |
			allMethods := IdentitySet new.
			cls methodsDo: [ :selector :aGsMethod |
				(aGsMethod _selectorPool, aGsMethod literals) do: [ :lit |
					(lit isSymbol and: [lit includesString: searchText]) ifTrue: [ allMethods add: aGsMethod ]]].
			allMethods do: [:aGsMethod | 
				methods add: (self currentSystem methodReferenceClass class: cls selector: aGsMethod selector )]]].
	^ methods sorted: [:a :b | a selector <= b selector ]
! !
